From d8c3b1156113e2f578a253f2849fcbaf6eb618d6 Mon Sep 17 00:00:00 2001
From: David Lehman <dlehman@redhat.com>
Date: Mon, 14 Jan 2013 13:24:23 -0600
Subject: [PATCH 08/10] Move tsort, platform, and baseudev into storage.

Merge baseudev into storage.udev.
---
 anaconda                                  |   2 +-
 pyanaconda/__init__.py                    |  13 +-
 pyanaconda/baseudev.py                    |  95 -------
 pyanaconda/bootloader.py                  |  61 +++--
 pyanaconda/installclass.py                |   3 +-
 pyanaconda/kickstart.py                   |   1 -
 pyanaconda/packaging/__init__.py          |  11 +-
 pyanaconda/platform.py                    | 411 ------------------------------
 pyanaconda/pyudev.py                      | 232 -----------------
 pyanaconda/rescue.py                      |   4 +-
 pyanaconda/storage/__init__.py            |  27 +-
 pyanaconda/storage/dasd.py                |   2 +-
 pyanaconda/storage/devicetree.py          |   8 +-
 pyanaconda/storage/fcoe.py                |   2 +-
 pyanaconda/storage/formats/__init__.py    |   2 +-
 pyanaconda/storage/formats/biosboot.py    |   4 +-
 pyanaconda/storage/formats/fs.py          |   8 +-
 pyanaconda/storage/formats/prepboot.py    |   4 +-
 pyanaconda/storage/partitioning.py        |   3 -
 pyanaconda/storage/platform.py            | 409 +++++++++++++++++++++++++++++
 pyanaconda/storage/pyudev.py              | 232 +++++++++++++++++
 pyanaconda/storage/tsort.py               | 105 ++++++++
 pyanaconda/storage/udev.py                |  69 ++++-
 pyanaconda/tsort.py                       | 105 --------
 pyanaconda/ui/gui/spokes/storage.py       |   3 +-
 pyanaconda/ui/gui/tools/run-spoke.py      |   4 +-
 pyanaconda/ui/tui/tools/run-text-spoke.py |   4 +-
 tests/kickstart_test/commands_test.py     |   4 +-
 tests/pyanaconda_test/Makefile.am         |   1 -
 tests/pyanaconda_test/baseudev_test.py    | 139 ----------
 tests/storage_test/storagetestcase.py     |   2 +-
 tests/storage_test/tsort_test.py          |  62 +++++
 tests/storage_test/udev_test.py           | 139 ++++++++++
 tests/tsort_test.py                       |  62 -----
 34 files changed, 1083 insertions(+), 1150 deletions(-)
 delete mode 100644 pyanaconda/baseudev.py
 delete mode 100644 pyanaconda/platform.py
 delete mode 100644 pyanaconda/pyudev.py
 create mode 100644 pyanaconda/storage/platform.py
 create mode 100644 pyanaconda/storage/pyudev.py
 create mode 100644 pyanaconda/storage/tsort.py
 delete mode 100644 pyanaconda/tsort.py
 delete mode 100644 tests/pyanaconda_test/baseudev_test.py
 create mode 100644 tests/storage_test/tsort_test.py
 create mode 100644 tests/storage_test/udev_test.py
 delete mode 100644 tests/tsort_test.py

diff --git a/anaconda b/anaconda
index 8de01c5..1891053 100755
--- a/anaconda
+++ b/anaconda
@@ -981,7 +981,7 @@ if __name__ == "__main__":
 
     if anaconda.rescue:
         from pyanaconda.rescue import doRescue
-        doRescue(anaconda.rescue_mount, ksdata, anaconda.platform)
+        doRescue(anaconda.rescue_mount, ksdata)
 
     threadMgr.add(AnacondaThread(name="AnaStorageThread", target=storageInitialize, args=(anaconda.storage, ksdata, anaconda.protected)))
     threadMgr.add(AnacondaThread(name="AnaNetworkThread", target=networkInitialize, args=(ksdata,)))
diff --git a/pyanaconda/__init__.py b/pyanaconda/__init__.py
index 0b8119b..4767080 100644
--- a/pyanaconda/__init__.py
+++ b/pyanaconda/__init__.py
@@ -63,7 +63,6 @@ class Anaconda(object):
         self._network = None
         self.opts = None
         self._payload = None
-        self._platform = None
         self.proxy = None
         self.proxyUsername = None
         self.proxyPassword = None
@@ -87,7 +86,7 @@ class Anaconda(object):
     @property
     def bootloader(self):
         if not self._bootloader:
-            self._bootloader = get_bootloader(self.platform)
+            self._bootloader = get_bootloader()
 
         return self._bootloader
 
@@ -141,14 +140,6 @@ class Anaconda(object):
         return self._payload
 
     @property
-    def platform(self):
-        if not self._platform:
-            from pyanaconda import platform
-            self._platform = platform.getPlatform()
-
-        return self._platform
-
-    @property
     def protected(self):
         import stat
 
@@ -165,7 +156,7 @@ class Anaconda(object):
     def storage(self):
         if not self._storage:
             import storage
-            self._storage = storage.Storage(data=self.ksdata, platform=self.platform)
+            self._storage = storage.Storage(data=self.ksdata)
 
         return self._storage
 
diff --git a/pyanaconda/bootloader.py b/pyanaconda/bootloader.py
index bb92444..be7a019 100644
--- a/pyanaconda/bootloader.py
+++ b/pyanaconda/bootloader.py
@@ -36,7 +36,7 @@ from pyanaconda.constants import *
 from pyanaconda.storage.errors import StorageError
 from pyanaconda.storage.fcoe import fcoe
 import pyanaconda.network
-from pyanaconda import platform as _platform
+from pyanaconda.storage import platform
 
 import gettext
 _ = lambda x: gettext.ldgettext("anaconda", x)
@@ -247,10 +247,7 @@ class BootLoader(object):
 
     _trusted_boot = False
 
-    def __init__(self, platform=None):
-        # pyanaconda.platform.Platform instance
-        self.platform = platform
-
+    def __init__(self):
         self.boot_args = Arguments()
         self.dracut_args = Arguments()
 
@@ -368,11 +365,11 @@ class BootLoader(object):
     #
     @property
     def disklabel_types(self):
-        return self.platform._disklabel_types
+        return platform.platform._disklabel_types
 
     @property
     def device_descriptions(self):
-        return self.platform.bootStage1ConstraintDict["descriptions"]
+        return platform.platform.bootStage1ConstraintDict["descriptions"]
 
     #
     # constraint checking for target devices
@@ -553,7 +550,7 @@ class BootLoader(object):
         self.errors = []
         self.warnings = []
         valid = True
-        constraint = self.platform.bootStage1ConstraintDict
+        constraint = platform.platform.bootStage1ConstraintDict
 
         if device is None:
             return False
@@ -696,7 +693,7 @@ class BootLoader(object):
                                      desc=self.stage2_description):
             valid = False
 
-        non_linux_format_types = self.platform._non_linux_format_types
+        non_linux_format_types = platform.platform._non_linux_format_types
         if non_linux and \
            not self._is_valid_format(device,
                                      format_types=non_linux_format_types):
@@ -979,8 +976,8 @@ class GRUB(BootLoader):
 
     packages = ["grub"]
 
-    def __init__(self, platform=None):
-        super(GRUB, self).__init__(platform=platform)
+    def __init__(self):
+        super(GRUB, self).__init__()
         self.encrypted_password = ""
 
     #
@@ -1355,8 +1352,8 @@ class GRUB2(GRUB):
     stage2_raid_levels = [mdraid.RAID0, mdraid.RAID1, mdraid.RAID4,
                           mdraid.RAID5, mdraid.RAID6, mdraid.RAID10]
 
-    def __init__(self, platform=None):
-        super(GRUB2, self).__init__(platform=platform)
+    def __init__(self):
+        super(GRUB2, self).__init__()
         self.boot_args.add("$([ -x /usr/sbin/rhcrashkernel-param ] && "\
                            "/usr/sbin/rhcrashkernel-param || :)")
 
@@ -1597,8 +1594,8 @@ class EFIGRUB(GRUB2):
     def _config_dir(self):
         return "efi/EFI/%s" % (self.efi_dir,)
 
-    def __init__(self, platform=None):
-        super(EFIGRUB, self).__init__(platform=platform)
+    def __init__(self):
+        super(EFIGRUB, self).__init__()
         self.efi_dir = 'BOOT'
 
     def efibootmgr(self, *args, **kwargs):
@@ -1986,8 +1983,8 @@ class ZIPL(BootLoader):
     image_label_attr = "short_label"
     preserve_args = ["cio_ignore"]
 
-    def __init__(self, platform=None):
-        super(ZIPL, self).__init__(platform=platform)
+    def __init__(self):
+        super(ZIPL, self).__init__()
         self.stage1_name = None
 
     #
@@ -2176,22 +2173,22 @@ class UBOOT(BootLoader):
 
 
 # every platform that wants a bootloader needs to be in this dict
-bootloader_by_platform = {_platform.X86: GRUB2,
-                          _platform.EFI: EFIGRUB,
-                          _platform.MacEFI: MacEFIGRUB,
-                          _platform.PPC: GRUB2,
-                          _platform.IPSeriesPPC: IPSeriesGRUB2,
-                          _platform.NewWorldPPC: MacYaboot,
-                          _platform.S390: ZIPL,
-                          _platform.Sparc: SILO,
-                          _platform.ARM: UBOOT,
-                          _platform.omapARM: UBOOT}
-
-def get_bootloader(platform):
-    platform_name = platform.__class__.__name__
-    cls = bootloader_by_platform.get(platform.__class__, BootLoader)
+bootloader_by_platform = {platform.X86: GRUB2,
+                          platform.EFI: EFIGRUB,
+                          platform.MacEFI: MacEFIGRUB,
+                          platform.PPC: GRUB2,
+                          platform.IPSeriesPPC: IPSeriesGRUB2,
+                          platform.NewWorldPPC: MacYaboot,
+                          platform.S390: ZIPL,
+                          platform.Sparc: SILO,
+                          platform.ARM: UBOOT,
+                          platform.omapARM: UBOOT}
+
+def get_bootloader():
+    platform_name = platform.platform.__class__.__name__
+    cls = bootloader_by_platform.get(platform.platform.__class__, BootLoader)
     log.info("bootloader %s on %s platform" % (cls.__name__, platform_name))
-    return cls(platform)
+    return cls()
 
 
 # anaconda-specific functions
diff --git a/pyanaconda/installclass.py b/pyanaconda/installclass.py
index 2e817f2..888d081 100644
--- a/pyanaconda/installclass.py
+++ b/pyanaconda/installclass.py
@@ -32,6 +32,7 @@ from constants import *
 from product import *
 from storage.partspec import *
 from storage.devicelibs import swap
+from storage.platform import platform
 
 import gettext
 _ = lambda x: gettext.ldgettext("anaconda", x)
@@ -105,7 +106,7 @@ class BaseInstallClass(object):
                                  size=500, grow=True, requiredSpace=50*1024,
                                  btr=True, lv=True, encrypted=True)]
 
-        bootreqs = storage.platform.setDefaultPartitioning()
+        bootreqs = platform.setDefaultPartitioning()
         if bootreqs:
             autorequests.extend(bootreqs)
 
diff --git a/pyanaconda/kickstart.py b/pyanaconda/kickstart.py
index f177cf4..b2abfaa 100644
--- a/pyanaconda/kickstart.py
+++ b/pyanaconda/kickstart.py
@@ -43,7 +43,6 @@ import shlex
 import sys
 import urlgrabber
 import pykickstart.commands as commands
-from storage.devices import *
 from pyanaconda.storage import arch
 from pyanaconda import keyboard
 from pyanaconda import ntp
diff --git a/pyanaconda/packaging/__init__.py b/pyanaconda/packaging/__init__.py
index 0ec42e8..57e982a 100644
--- a/pyanaconda/packaging/__init__.py
+++ b/pyanaconda/packaging/__init__.py
@@ -55,6 +55,7 @@ from pyanaconda.errors import *
 from pyanaconda.storage.errors import StorageError
 from pyanaconda.storage import util
 from pyanaconda.storage import arch
+from pyanaconda.storage.platform import platform
 #from pyanaconda.progress import progress
 
 from pyanaconda.product import productName, productVersion
@@ -655,8 +656,8 @@ class PackagePayload(Payload):
 
         # most ARM systems use platform-specific kernels
         if arch.isARM():
-            if self.storage.platform.armMachine is not None:
-                kernels = ["kernel-%s" % self.storage.platform.armMachine]
+            if platform.armMachine is not None:
+                kernels = ["kernel-%s" % platform.armMachine]
 
         return kernels
 
@@ -721,7 +722,6 @@ if __name__ == "__main__":
     import os
     import sys
     import pyanaconda.storage as _storage
-    import pyanaconda.platform as _platform
     from pykickstart.version import makeVersion
     from pyanaconda.packaging.yumpayload import YumPayload
 
@@ -735,9 +735,8 @@ if __name__ == "__main__":
     #ksdata.method.url = "http://husky/install/f17/os/"
     #ksdata.method.url = "http://dl.fedoraproject.org/pub/fedora/linux/development/17/x86_64/os/"
 
-    # set up storage and platform
-    platform = _platform.getPlatform()
-    storage = _storage.Storage(data=ksdata, platform=platform)
+    # set up storage
+    storage = _storage.Storage(data=ksdata)
     storage.reset()
 
     # set up the payload
diff --git a/pyanaconda/rescue.py b/pyanaconda/rescue.py
index ed06592..2fc5722 100644
--- a/pyanaconda/rescue.py
+++ b/pyanaconda/rescue.py
@@ -191,7 +191,7 @@ def runShell(screen = None, msg=""):
     if screen:
         screen.finish()
 
-def doRescue(rescue_mount, ksdata, platform):
+def doRescue(rescue_mount, ksdata):
     import storage
 
     for file in [ "services", "protocols", "group", "joe", "man.config",
@@ -242,7 +242,7 @@ def doRescue(rescue_mount, ksdata, platform):
 
             break
 
-    sto = storage.Storage(ksdata, platform)
+    sto = storage.Storage(ksdata)
     storage.storageInitialize(sto, ksdata, [])
     roots = storage.findExistingInstallations(sto.devicetree)
 
diff --git a/pyanaconda/storage/__init__.py b/pyanaconda/storage/__init__.py
index f6cd380..bc973e3 100644
--- a/pyanaconda/storage/__init__.py
+++ b/pyanaconda/storage/__init__.py
@@ -41,7 +41,6 @@ import nss.nss
 import parted
 
 from pykickstart.constants import *
-from pyanaconda import tsort
 
 from storage_log import log_method_call
 from errors import *
@@ -69,6 +68,7 @@ import dasd
 import util
 import arch
 from flags import flags
+from platform import platform as _platform
 
 import shelve
 import contextlib
@@ -278,17 +278,14 @@ class StorageDiscoveryConfig(object):
         self.zeroMbr = ksdata.zerombr.zerombr
 
 class Storage(object):
-    def __init__(self, data=None, platform=None):
+    def __init__(self, data=None):
         """ Create a Storage instance.
 
             Keyword Arguments:
 
                 data        -   a pykickstart Handler instance
-                platform    -   a Platform instance
-
         """
         self.data = data
-        self.platform = platform
         self._bootloader = None
 
         self.config = StorageDiscoveryConfig()
@@ -784,9 +781,6 @@ class Storage(object):
                 - Needs some error handling
 
         """
-        if not hasattr(self.platform, "diskLabelTypes"):
-            raise StorageError("can't clear partitions without platform data")
-
         # Sort partitions by descending partition number to minimize confusing
         # things like multiple "destroy sda5" actions due to parted renumbering
         # partitions. This can still happen through the UI but it makes sense to
@@ -842,10 +836,7 @@ class Storage(object):
         destroy_action = ActionDestroyFormat(disk)
         self.devicetree.registerAction(destroy_action)
 
-        if self.platform:
-            labelType = self.platform.bestDiskLabelType(disk)
-        else:
-            labelType = None
+        labelType = _platform.bestDiskLabelType(disk)
 
         # create a new disklabel on the disk
         newLabel = getFormat("disklabel", device=disk.path,
@@ -1049,7 +1040,7 @@ class Storage(object):
             if fmt:
                 mountpoint = getattr(fmt, "mountpoint", None)
 
-                kwargs["weight"] = self.platform.weight(mountpoint=mountpoint,
+                kwargs["weight"] = _platform.weight(mountpoint=mountpoint,
                                                         fstype=fmt.type)
 
 
@@ -1569,7 +1560,7 @@ class Storage(object):
             #
             # check that GPT boot disk on BIOS system has a BIOS boot partition
             #
-            if self.platform.weight(fstype="biosboot") and \
+            if _platform.weight(fstype="biosboot") and \
                stage1 and stage1.isDisk and \
                getattr(stage1.format, "labelType", None) == "gpt":
                 missing = True
@@ -1645,8 +1636,7 @@ class Storage(object):
     @property
     def packages(self):
         pkgs = set()
-        if self.platform:
-            pkgs.update(self.platform.packages)
+        pkgs.update(_platform.packages)
 
         if self.bootloader:
             pkgs.update(self.bootloader.packages)
@@ -1691,9 +1681,8 @@ class Storage(object):
 
     @property
     def bootloader(self):
-        if self._bootloader is None and self.platform is not None and \
-           flags.installer_mode:
-            self._bootloader = get_bootloader(self.platform)
+        if self._bootloader is None and flags.installer_mode:
+            self._bootloader = get_bootloader()
 
         return self._bootloader
 
diff --git a/pyanaconda/storage/dasd.py b/pyanaconda/storage/dasd.py
index abf97b9..bd3d4de 100644
--- a/pyanaconda/storage/dasd.py
+++ b/pyanaconda/storage/dasd.py
@@ -26,7 +26,7 @@ from pyanaconda.storage.devices import deviceNameToDiskByPath
 from pyanaconda.storage import util
 from pyanaconda.storage import arch
 from . import ROOT_PATH
-from pyanaconda.baseudev import udev_trigger
+from .udev import udev_trigger
 
 import logging
 log = logging.getLogger("storage")
diff --git a/pyanaconda/storage/devicetree.py b/pyanaconda/storage/devicetree.py
index dff17ae..106b397 100644
--- a/pyanaconda/storage/devicetree.py
+++ b/pyanaconda/storage/devicetree.py
@@ -41,8 +41,8 @@ import devicelibs.loop
 import devicelibs.edd
 from udev import *
 import util
-from pyanaconda import platform
-from pyanaconda import tsort
+from platform import platform
+import tsort
 from flags import flags
 from storage_log import log_method_call, log_method_return
 import parted
@@ -177,8 +177,6 @@ class DeviceTree(object):
         self.dasd = dasd
         self.mpathFriendlyNames = getattr(conf, "mpathFriendlyNames", True)
 
-        self.platform = platform.getPlatform()
-
         self.diskImages = {}
         images = getattr(conf, "diskImages", {})
         if images:
@@ -1144,7 +1142,7 @@ class DeviceTree(object):
 
         # we're going to pass the "best" disklabel type into the DiskLabel
         # constructor, but it only has meaning for non-existent disklabels.
-        labelType = self.platform.bestDiskLabelType(device)
+        labelType = platform.bestDiskLabelType(device)
 
         try:
             format = getFormat("disklabel",
diff --git a/pyanaconda/storage/fcoe.py b/pyanaconda/storage/fcoe.py
index 22c6258..8e8e301 100644
--- a/pyanaconda/storage/fcoe.py
+++ b/pyanaconda/storage/fcoe.py
@@ -19,7 +19,7 @@
 
 import os
 from . import util
-from pyanaconda.baseudev import udev_settle
+from .udev import udev_settle
 #from pyanaconda import isys
 from . import ROOT_PATH
 import logging
diff --git a/pyanaconda/storage/formats/__init__.py b/pyanaconda/storage/formats/__init__.py
index 8a51cfe..62122fb 100644
--- a/pyanaconda/storage/formats/__init__.py
+++ b/pyanaconda/storage/formats/__init__.py
@@ -22,7 +22,7 @@
 
 import os
 
-from pyanaconda.baseudev import udev_get_device
+from ..udev import udev_get_device
 from ..util import notify_kernel
 from ..util import get_sysfs_path_by_name
 from ..util import run_program
diff --git a/pyanaconda/storage/formats/biosboot.py b/pyanaconda/storage/formats/biosboot.py
index 861b591..c3aef8d 100644
--- a/pyanaconda/storage/formats/biosboot.py
+++ b/pyanaconda/storage/formats/biosboot.py
@@ -23,6 +23,7 @@
 from parted import PARTITION_BIOS_GRUB
 
 from ..errors import *
+from .. import platform
 from . import DeviceFormat, register_device_format
 
 class BIOSBoot(DeviceFormat):
@@ -53,8 +54,7 @@ class BIOSBoot(DeviceFormat):
 
     @property
     def supported(self):
-        from pyanaconda import platform
-        return isinstance(platform.getPlatform(), platform.X86)
+        return isinstance(platform.platform, platform.X86)
 
 register_device_format(BIOSBoot)
 
diff --git a/pyanaconda/storage/formats/fs.py b/pyanaconda/storage/formats/fs.py
index 1d355c3..b472e87 100644
--- a/pyanaconda/storage/formats/fs.py
+++ b/pyanaconda/storage/formats/fs.py
@@ -35,6 +35,7 @@ import selinux
 from ..errors import *
 from . import DeviceFormat, register_device_format
 from .. import util
+from .. import platform
 from ..flags import flags
 from parted import fileSystemType
 from ..storage_log import log_method_call
@@ -975,9 +976,7 @@ class EFIFS(FATFS):
 
     @property
     def supported(self):
-        from pyanaconda import platform
-        p = platform.getPlatform()
-        return (isinstance(p, platform.EFI) and
+        return (isinstance(platform.platform, platform.EFI) and
                 self.utilsAvailable)
 
 register_device_format(EFIFS)
@@ -1210,8 +1209,7 @@ class AppleBootstrapFS(HFS):
 
     @property
     def supported(self):
-        from pyanaconda import platform
-        return (isinstance(platform.getPlatform(), platform.NewWorldPPC)
+        return (isinstance(platform.platform, platform.NewWorldPPC)
                 and self.utilsAvailable)
 
 register_device_format(AppleBootstrapFS)
diff --git a/pyanaconda/storage/formats/prepboot.py b/pyanaconda/storage/formats/prepboot.py
index 884aa8f..dd2cf8c 100644
--- a/pyanaconda/storage/formats/prepboot.py
+++ b/pyanaconda/storage/formats/prepboot.py
@@ -21,6 +21,7 @@
 #
 
 from ..errors import *
+from .. import platform
 from . import DeviceFormat, register_device_format
 from parted import PARTITION_PREP
 import os
@@ -80,8 +81,7 @@ class PPCPRePBoot(DeviceFormat):
 
     @property
     def supported(self):
-        from pyanaconda import platform
-        return isinstance(platform.getPlatform(), platform.IPSeriesPPC)
+        return isinstance(platform.platform, platform.IPSeriesPPC)
 
 register_device_format(PPCPRePBoot)
 
diff --git a/pyanaconda/storage/partitioning.py b/pyanaconda/storage/partitioning.py
index 64aa250..243c62b 100644
--- a/pyanaconda/storage/partitioning.py
+++ b/pyanaconda/storage/partitioning.py
@@ -721,9 +721,6 @@ def doPartitioning(storage):
             None
 
     """
-    if not hasattr(storage.platform, "diskLabelTypes"):
-        raise StorageError(_("can't allocate partitions without platform data"))
-
     disks = storage.partitioned
     if storage.config.exclusiveDisks:
         disks = [d for d in disks if d.name in storage.config.exclusiveDisks]
